#!/bin/sh
#A prxima linha reinicia usando o wish \
    exec wish "$0" "$@"
puts "Mdulo ismatec.tcl carregado!"

#Para bloquear o redimensionamento pelo usurio
wm resizable . 0 0 


#Obtmm o diretrio atual do script

set dir [file dirname [info script]]

#Adiciona ao path de bibliotecas o diretrio
#objLab (Objetos de Laboratrio)
lappend auto_path [file join $dir objLab_04]

#Carrega a biblioteca de Objetos de Laboratrio
#objLab no diretrio objLab
package require objLab 0.4

#Comando para importar
#namespace import equip_lab::*

#****************************************************************************
#Array que vai armazenar os diferentes modelos de tubos usados com as
#respectivas razes vazo/rpm permitindo calcular os volumes bombeados
#para os diferentes tubos em diferentes rotaes
#****************************************************************************
set cte_tubo(LS_13) 0.0600
set cte_tubo(LS_14) 0.2166
set cte_tubo(LS_16) 0.7500
#set cte_tubo(Ismatec_Azul_Verde) 0.1377
set cte_tubo(Ismatec_Azul_Verde) 0.1378

#****************************************************************************
#Array que vai armazenar os diferentes modelos de tubos usados com as
#respectivas razes steps/mL permitindo calcular o nmero de steps necessrios
#para os respectivos volumes
#****************************************************************************
set cte_step_tubo(Ismatec_Azul_Verde) 23.81


#Teste de criao dos objetos


#Criando objetos da classe bomba_peristaltica
#equip_lab::bomba_peristaltica ismatec_1 ismatec_2 Masterflex

#puts "Testando o uso do objeto ismatec_2 [equip_lab::ismatec_2 get_ID_bomba_per]"
#puts "Bomba ismatec_2 número [equip_lab::ismatec_2 get_ID_bomba_per]"
#equip_lab::ismatec_2 def_ID_bomba_per 1
#puts "Bomba ismatec_2 número [equip_lab::ismatec_2 get_ID_bomba_per]\n"

#Entrada de marca_modelo deve ser no formato de lista
#puts "Marca e Modelo Bomba ismatec_2 [equip_lab::ismatec_2 get_marca_modelo_bomba_per]"
#equip_lab::ismatec_2 def_marca_modelo_bomba_per [list ismatec IPC]
#puts "Marca da Bomba ismatec [lindex [equip_lab::ismatec_2 get_marca_modelo_bomba_per] 0]"
#puts "Modelo da Bomba ismatec [lindex [equip_lab::ismatec_2 get_marca_modelo_bomba_per] 1]\n"

#Definio do nmero de canais usados
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# possui [equip_lab::ismatec_2 get_num_canais_bomba] canais"
#equip_lab::ismatec_2 def_num_canais_bomba 8
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# possui [equip_lab::ismatec_2 get_num_canais_bomba] canais\n"


#Definio do status da bomba
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_2 get_bomba_status]"
#equip_lab::ismatec_2 def_bomba_status OPERACIONAL
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_2 get_bomba_status]\n"

#Definio do sentido de rotacao da bomba
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_2 get_sentido_rotacao_bomba]"
#equip_lab::ismatec_2 def_sentido_rotacao_bomba horario
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_2 get_sentido_rotacao_bomba]\n"

#Definio do modelo de tubo
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# usa tubo com cte [equip_lab::ismatec_2 get_tubo_modelo]"
#equip_lab::ismatec_2 def_tubo_modelo 0.5
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# usa tubo com cte [equip_lab::ismatec_2 get_tubo_modelo]\n"

#Teste dos mtodos da classe porta serial

#porta_serial porta_1 porta_2 porta_3 porta_4

#puts "Nome do disp da Porta serial porta_2 -> [porta_2 get_nome_disp_serial]"
#porta_2 def_nome_disp_serial "/dev/ttyS"
#puts "Nome do disp da Porta serial porta_2 -> [porta_2 get_nome_disp_serial]\n"

#puts "Num. do disp da Porta serial porta_2 -> [porta_2 get_numero_disp_serial]"
#porta_2 def_numero_disp_serial "0"
#puts "Num. do disp da Porta serial porta_2 -> [porta_2 get_numero_disp_serial]\n"

#puts "Par_com da Porta serial porta_2 -> [porta_2 get_par_com_porta_serial]"
#porta_2 def_par_com_porta_serial [list 4800,o,7,1]
#puts "Par_com da porta serial porta_2 -> [porta_2 get_par_com_porta_serial]\n"

#puts "Status da Porta serial porta_2 -> [porta_2 get_status_porta_serial]"
#porta_2 def_status_porta_serial SERIAL_OPEN
#puts "Status da Porta serial porta_2 -> [porta_2 get_status_porta_serial]\n"

#puts "Comando porta_serial_abrir\n"
#porta_2 porta_serial_abrir


#puts "ID da Porta serial porta_2 -> [porta_2 get_ID_porta_serial]\n"

#puts "Status da Porta serial porta_2 -> [porta_2 get_status_porta_serial]\n"


#Definio da porta serial
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# usa porta serial [equip_lab::ismatec_2 get_porta_serial_bomba]"
#equip_lab::ismatec_2 def_porta_serial_bomba porta_2
#puts "Bomba [equip_lab::ismatec_2 get_marca_modelo_bomba_per] \
# usa porta serial [equip_lab::ismatec_2 get_porta_serial_bomba]\n"

#Comando iniciar_bomba
#puts [equip_lab::ismatec_2 iniciar_bomba "2H"]


#set id_serial [[equip_lab::ismatec_2 get_porta_serial_bomba] get_ID_porta_serial]
#puts "ID_serial de [equip_lab::ismatec_2 get_porta_serial_bomba]: $id_serial"



#Comando parar_bomba
#puts [equip_lab::ismatec_2 parar_bomba "2I"]


#porta_2 porta_serial_fechar

#puts "ID da Porta serial porta_2 -> [porta_2 get_ID_porta_serial]\n"

#puts "Status da Porta serial porta_2 -> [porta_2 get_status_porta_serial]\n"


#equip_lab::remover_bomba_peristaltica ismatec_1 ismatec_2 Masterflex

#remover_porta_serial porta_1 porta_2 porta_3 porta_4

#########################################################################
#No procedimento abrir_porta tivemos que criar a variável global 
#numero_anterior para lidar com a possibilidade de mudana do nmero
#do dispositivo serial
#Na primeira execuo 
#########################################################################

proc abrir_porta { nome numero } {
    
   # puts "Dentro do procedimento abrir_porta"
    
    global numero_anterior  nome_ps 
    
    if { ![info exists numero_anterior] } { 
	    set numero_anterior $numero 
	}
	
	if { $numero != $numero_anterior } { 
		#porta_$numero_anterior porta_serial_fechar
		remover_porta_serial porta_$numero_anterior
		set nome_ps ""
		set numero_anterior $numero
	    }
	    
	    if { ![catch { set id_porta [porta_$numero get_ID_porta_serial] } ] } {
		    if { ![catch { tell $id_porta } ] } { 
	#puts "\n$id_porta existe e est aberta!\n"
			    return $id_porta 
			} else {
			    remover_porta_serial porta_$numero
			}
		}
		
#Inclumos o comando para fechar a porta serial dentro da rotina
#remover_porta_serial para simplificar a programao e por isso
#dispensamos o uso do comando porta_serial_fechar
		
#	    catch { porta_$numero porta_serial_fechar }
		
	
		
		porta_serial porta_$numero
		
		set nome_ps porta_$numero
		
		porta_$numero def_nome_disp_serial $nome
		
		porta_$numero def_numero_disp_serial $numero
		
		porta_$numero def_par_com_porta_serial [list 9600,n,8,1]
		
		porta_$numero porta_serial_abrir
		
		#puts "\nNome -> [porta_$numero get_nome_disp_serial]"
		#puts "Numero -> [porta_$numero get_numero_disp_serial]"
		#puts "ID -> [porta_$numero get_ID_porta_serial]"
		#puts "Status -> [porta_$numero get_status_porta_serial]\n"
	     
#Estamos retornando apenas o status SERIAL_ERRO_OPEN mesmo que o
#erro seja de configurao para ficar compatvel com o programa
#bomba.tcl
	
		
		if { [porta_$numero get_status_porta_serial] == \
		    "SERIAL_ERRO_OPEN" } {
			return "SERIAL_ERRO_OPEN"
		    } elseif { [porta_$numero get_status_porta_serial] == \
			"SERIAL_ERRO_CONFIG" } {
			return "SERIAL_ERRO_OPEN"
		    } else {
#Configurar a porta serial para timeout para os comandos read
			fconfigure [porta_$numero get_ID_porta_serial]\
 -timeout 500
			return [porta_$numero get_ID_porta_serial]	    
		    }
		    
}


##########################################################
#Para formatar o valor de velocidade usar o comando 
#[format %04d $a] ou [format %.4d $a]
#pois o comando para ajuste da velocidade deve
#ser formatado como 1S#### (#### -> 0001-0100)
##########################################################

##########################################################
#No procedimento bombear tivemos que criar a variável 
#global nome_ps para armazenar o nome do objeto da classe porta
#serial para poder enviar comandos pela porta serial
#sem usar o identificador da porta
#Quando o programa bomba foi concebido usamos o identificador
#da porta para comunicação com a bomba
#Mas agora com o uso dos objetos vamos procurar evitar esse
#recurso sem alterar o funcionamento da interface bomba.tcl
##########################################################



proc bombear { porta tubo sentido vazao volume } {

global cte_tubo nome_ps tempo_total_op tempo_inicial_op vazao_op
global cte_step_tubo

puts "Dentro do procedimento bombear"

#Comando regsub usado para substituir as ocorrncias de , por . 
		# possvel usar \\. e \\, ou {\.} e {,} ou {,}
set volume [regsub {\,} $volume \. ]
set vazao [regsub {\,} $vazao {.} ]

#Clculo do tempo total de operao em min que ser usado
#para acompanhar a execuo da operao
set volume [format "%.2f" $volume]
set vazao [format "%.2f" $vazao]
set tempo_total_op [format "%.2f" [expr $volume / $vazao]]
set vazao_op $vazao

if { [catch { set id_bomba [equip_lab::ismatec_1 get_ID_bomba_per] } ] } {

#Criando objeto da classe bomba_peristaltica
equip_lab::bomba_peristaltica ismatec_1

}

#Definindo ID da bomba
equip_lab::ismatec_1 def_ID_bomba_per 1

#Definindo o status CONFIGURANDO
equip_lab::ismatec_1 def_bomba_status CONFIGURANDO

#Definindo marca, modelo e nmero de canais
equip_lab::ismatec_1 def_marca_modelo_bomba_per [list ismatec IPC]
equip_lab::ismatec_1 def_num_canais_bomba 8

#Traduzindo o caracter do sentido de rotao de + -> h e - -> ah

if {$sentido == "+"} {
set sentido h
} elseif {$sentido == "-"} {
set sentido ah
}

equip_lab::ismatec_1 def_sentido_rotacao_bomba $sentido


if { [catch {set ct $cte_tubo($tubo)}] } {
	tk_messageBox -message "Desculpe, mas o tubo $tubo no  compatvel \
com esta bomba!" 
	    return
	}

#Definio do modelo de tubo
equip_lab::ismatec_1 def_tubo_modelo $tubo

#Definio da porta serial a ser usada, neste caso nome_ps armazena
#o nome do objeto da classe porta serial
equip_lab::ismatec_1 def_porta_serial_bomba $nome_ps

#puts "Bomba ismatec_1 nmero [equip_lab::ismatec_1 get_ID_bomba_per]\n"
#puts "Modelo da Bomba ismatec [lindex [equip_lab::ismatec_1 get_marca_modelo_bomba_per] 1]\n"
#puts "Bomba [equip_lab::ismatec_1 get_marca_modelo_bomba_per] \
# possui [equip_lab::ismatec_1 get_num_canais_bomba] canais\n"
#puts "Bomba [equip_lab::ismatec_1 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_1 get_bomba_status]\n"
#puts "Bomba [equip_lab::ismatec_1 get_marca_modelo_bomba_per] \
# est [equip_lab::ismatec_1 get_sentido_rotacao_bomba]\n"
#puts "Bomba [equip_lab::ismatec_1 get_marca_modelo_bomba_per] \
# usa tubo com cte [equip_lab::ismatec_1 get_tubo_modelo]\n"
#puts "Bomba [equip_lab::ismatec_1 get_marca_modelo_bomba_per] \
#usa porta serial [equip_lab::ismatec_1 get_porta_serial_bomba]\n"

##################################################################
#Configurando o sentido de rotao
##################################################################

#Usamos os comandos das classes apenas para testar mas poderamos
#usar o parmetro "porta"
set obj_porta_serial [equip_lab::ismatec_1 get_porta_serial_bomba]
set ps [$obj_porta_serial get_ID_porta_serial]

if { $sentido == "h"} {
	puts  $ps "1J"
	flush $ps
    } elseif { $sentido == "ah"} {
	puts $ps "1K"
	flush $ps
    }
 
#Comando para limpar o buffer da porta serial 
#poderiamos usar tanto porta quanto ps
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"

##################################################################
#Configurando a velocidade de rotao (vazo)
##################################################################

   
#Clculo da velocidade de rotao em % a partir da vazo (ml/min)
#Para formatar o valor de velocidade usar o comando 
#[format %04d $a] ou [format %.4d $a]
#pois o comando para ajuste da velocidade deve
#ser formatado como 1S#### (#### -> 0001-0100)


set veloc [expr $vazao / $cte_tubo($tubo)]

if {($veloc < 1) || ($veloc > 100)} {
	tk_messageBox -message "Desculpe, mas esta vazo ($veloc) com o tubo $tubo \
est fora dos limites operacionais desta bomba!" 
	    return
	}

#Usamos o comando round para arredondar o valor da velocidade
#antes do comando format

set veloc [expr round($veloc)]

#puts "\nVeloc antes -> $veloc"
set veloc [format %04d $veloc]
#puts "Veloc depois -> $veloc\n"

puts  $ps "1S$veloc"
flush $ps

#Comando para limpar o buffer da porta serial 
#poderiamos usar tanto porta quanto ps
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"

##################################################################
#Configurando o modo "step" de operao
##################################################################


#Configurando a bomba para operar no modo "step"
puts $ps "1N"
flush $ps

#Comando para limpar o buffer da porta serial 
#poderiamos usar tanto porta quanto ps
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"

##################################################################
#Configurando o nmero de rotaes
##################################################################


#Clculo do nmero de rotaes para bombear o volume especificado
#pelo usurio rotacoes=volume/k 

    set rotacoes [expr $volume * $cte_step_tubo($tubo)]

if { $rotacoes > 9999 } {
	tk_messageBox -message "Desculpe, mas este volume com o tubo $tubo \
 est fora dos limites operacionais desta bomba!" 
	    return
	}

#Usamos o comando round para arredondar o nmero de rotaes (steps)
#antes do comando format

set rotacoes [expr round($rotacoes)]

#puts "\nRotacoes antes -> $rotacoes"
set rotacoes [format %04d $rotacoes]
#puts "Rotacoes depois -> $rotacoes\n"

puts  $ps "1U$rotacoes"
flush $ps

#Comando para limpar o buffer da porta serial 
#poderiamos usar tanto porta quanto ps
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"

##################################################################
#Iniciar a operao
##################################################################


#Aps configurar o sentido de rotao, vazo
#e volume definir o status OPERACIONAL
equip_lab::ismatec_1 def_bomba_status OPERACIONAL


equip_lab::ismatec_1 iniciar_bomba "1H"


#Comando para limpar o buffer da porta serial 
#poderiamos usar tanto porta quanto ps
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"
   
#Define a varivel global tempo_inicial_op que ser usada
#para monitorar o tempo previsto da operao com o tempo
#real e detectar se houve interrupo da operao

set tempo_inicial_op [clock seconds]

}



#O procedimento informar deve retornar uma lista com
#trs elementos:
#0 - status_bomba {mensagens especficas para cada mdulo}
#1 - vol_real
#2 - status_dados { 0 (OK) e 1 (PROBLEMAS)
#{"estado da bomba" "volume bombeado" "estado dos dados"}
#Criamos a varivel global vazao_op para poder estimar o volume
#bombeado a partir do tempo decorrido

proc informar { porta tubo } {
    
    global cte_tubo vazao_op
    
    puts $porta "1E"
    flush $porta
    
    set resposta [ler_resposta $porta]
    
 #   puts "Dentro da rotina informar"
 #   puts "resposta -> $resposta\n"
    
    if { $resposta == "+" } {
	    set status_b "Bomba em funcionamento"
	} elseif { $resposta == "-" } {
	    set status_b "Bomba parada"
	} elseif { $resposta == "SERIAL_ERRO_TIMEOUT" } {
	set status_b "SERIAL_ERRO_TIMEOUT"
	}

set tempo_op  [calc_tempo_op]
set vol_bombeado [expr $tempo_op * $vazao_op]

#puts "\n Dentro da rotina informar\n"
#puts "\n tempo_op -> $tempo_op e vol_bombeado -> $vol_bombeado"

	return [list $status_b $vol_bombeado 0]
	
}


#O comando parar apenas envia o comando de parada para a bomba
#Ismatec sem fechar a porta
#O fechamento da porta fica a cargo da rotina abrir_porta quando
#houver mudanaa do nmero do dispositivo

proc parar { porta } {


#puts "\nDentro do comando parar - porta -> $porta"

equip_lab::ismatec_1 parar_bomba "1I"

#Comando para limpar o buffer da porta serial
set resposta [ler_resposta $porta]
#puts "retorno_bomba -> $resposta"

#set obj_porta_serial [equip_lab::ismatec_1 get_porta_serial_bomba]
#set retorno_bomba [read [$obj_porta_serial get_ID_porta_serial]]

equip_lab::remover_bomba_peristaltica ismatec_1

}

######################################################################
#Procedimento para a leitura do retorno da bomba para qualquer comando 
#Esta rotina le apenas um byte de cada vez no limite do timeout
######################################################################

proc ler_resposta { porta } {
    
    global  nome_ps
    
    
    set leitura [catch {set caractere [read $porta 1]}]
    
	#Verifica se no houve erro de leitura
    if {$leitura} {
	    $nome_ps def_status_porta_serial SERIAL_ERRO_READ
	    return [$nome_ps get_status_porta_serial]
	}
	
        # Se nenhum byte for recebido, ocorreu um TIMEOUT.
        if {$caractere == ""} {
		$nome_ps def_status_porta_serial SERIAL_ERRO_TIMEOUT
		return [$nome_ps get_status_porta_serial]
            } else {
		return $caractere
	    }
            
}

###################################################################
#Procedimento para calcular o volume bombeado baseado no tempo
#necessário (T) para bombear um volume (V) com uma vazão (Q) 
#(Q = V/T)
###################################################################

proc calc_tempo_op {} {

global tempo_total_op tempo_inicial_op

#puts "\nDentro da rotina calc_tempo_op\n"

#puts "\nTempo total de operacao -> $tempo_total_op (min)\n"

set tempo_atual [clock seconds]

set tempo_op [expr $tempo_atual - $tempo_inicial_op] 

#puts "\nTempo decorrido -> $tempo_op (s)\n"

set tempo_op [expr $tempo_op / 60.0]

return $tempo_op

}

#Toplevel para exibir os comandos para definir e executar
#a operao reversa e o nmero de repeties

proc op_reversa { } {

global fonte_media

#Para bloquear o redimensionamento pelo usurio

destroy .op_rev
toplevel .op_rev

wm resizable .op_rev 0 0 


label .op_rev.rotulo -text "Condies da operao reversa." -font $fonte_media

labelframe .op_rev.sentido -text "Sentido de Rotao" -font $fonte_media
radiobutton .op_rev.sentido.horario -text "Horrio" -font $fonte_media\
    -variable sentido_rotacao_rev  -value "+" 
radiobutton .op_rev.sentido.antihorario -text "Anti-Horrio" \
    -font $fonte_media \
    -variable sentido_rotacao_rev -value "-"


#****************************************************************************
#Criando o spinbox ao lado do label "Vazo (mL/min)"
#para configurar a vazão com a qual a bomba deve bombear no modo reverso
#****************************************************************************


frame .op_rev.vaz
label .op_rev.vaz.rotulo -text "Vazo (mL/min)" -font $fonte_media
spinbox .op_rev.vaz.entrada  -from 0 -to 200 -increment 5 -bg white \
    -textvariable vazao_rev \
    -width 4 -command {} \
    -font $fonte_media

grid .op_rev.vaz.rotulo -row 2 -column 0 -sticky w
grid .op_rev.vaz.entrada -row 2 -column 1 -sticky ew -pady 2


#****************************************************************************
#Criando o spinbox ao lado do label "Volume (ml)"
#para configurar o volume que a bomba deve bombear no modo reverso
#****************************************************************************

frame .op_rev.vol

label .op_rev.vol.rotulo -text "Volume (mL)"  -font $fonte_media
spinbox .op_rev.vol.entrada  -from 0 -to 50000 -increment 10 -bg white \
    -textvariable volume_rev \
    -width 4 -command {} \
    -font $fonte_media

grid .op_rev.vol.rotulo -row 3 -column 0 -sticky w
grid .op_rev.vol.entrada -row 3 -column 1 -sticky ew -pady 2


#****************************************************************************
#Criando o spinbox ao lado do label "Repeties"
#para configurar o nmero de repeties das operaes normal e reversa
#****************************************************************************

frame .op_rev.rep

label .op_rev.rep.rotulo -text "Repeties"  -font $fonte_media
spinbox .op_rev.rep.entrada  -from 0 -to 50000 -increment 1 -bg white \
    -textvariable repeticoes \
    -width 4 -command {} \
    -font $fonte_media

grid .op_rev.rep.rotulo -row 3 -column 0 -sticky w
grid .op_rev.rep.entrada -row 3 -column 1 -sticky ew -pady 2

label .op_rev.info -text "Operao 0" -font $fonte_media


#*****************************************************************************
#Botões de controle
#*****************************************************************************

frame .op_rev.botoes

button .op_rev.botoes.iniciar -text "Iniciar Ciclo"  -font $fonte_media -command { 
iniciar_ciclo $repeticoes
}

button .op_rev.botoes.parar -text "Parar Ciclo"  -font $fonte_media -command { 
parar_ciclo $porta_serial $num_porta_serial
}

pack .op_rev.botoes.iniciar .op_rev.botoes.parar -side right -expand yes \
    -fill both

pack .op_rev.rotulo

pack .op_rev.sentido
pack .op_rev.sentido.horario -anchor w
pack .op_rev.sentido.antihorario -anchor w

pack .op_rev.vaz

pack .op_rev.vol

pack .op_rev.rep

pack .op_rev.info

pack .op_rev.botoes -expand yes -fill both 

}

proc iniciar_ciclo { rep } {

global porta_serial num_porta_serial tubo_em_uso 
global sentido_rotacao vazao volume
global sentido_rotacao_rev vazao_rev volume_rev 

global cont_ciclo

#set operacao_normal INICIO

#set tempo_espera_op_normal [expr 60000 * $tempo_total_op]

#set tempo_espera_op_normal [expr round($tempo_espera_op_normal)]

#after $tempo_espera_op_normal [list set operacao_normal FIM]

set cont_ciclo 1

.op_rev.botoes.iniciar configure -state disable

for {set i 0} {$i < $rep} {incr i} {


puts "\n***************************************************"
puts "\nProcedimento iniciar_ciclo - Incio da operao normal\n"
puts "***************************************************\n"

if {!$cont_ciclo} { 
puts "Ciclo Interrompido"
break
 }

.op_rev.info configure -text "Operao [expr 2 * $i]/[expr 2 * $rep] \
- Normal"

iniciar $porta_serial $num_porta_serial $tubo_em_uso $sentido_rotacao $vazao $volume

puts "\n***************************************************"
puts "Procedimento iniciar_ciclo - Fim da operao normal"
puts "***************************************************\n"

if {!$cont_ciclo} { 
puts "Ciclo Interrompido"
break }

puts "\n***************************************************"
puts "\nProcedimento iniciar_ciclo - Início da operao reversa\n"
puts "***************************************************\n"

.op_rev.info configure -text "Operao [expr (2 * $i) + 1]/[expr 2 * $rep] \
- Reversa"

iniciar $porta_serial $num_porta_serial $tubo_em_uso $sentido_rotacao_rev $vazao_rev $volume_rev

puts "\n***************************************************"
puts "Procedimento iniciar_ciclo - Fim da operao normal"
puts "***************************************************\n"

}

.op_rev.botoes.iniciar configure -state normal

}



proc parar_ciclo { porta num_porta } {

global cont_ciclo

set cont_ciclo 0

parar_op $porta $num_porta

}

op_reversa